[![Build Status](https://travis-ci.org/Availity/availity-reactstrap-validation.svg?branch=master)](https://travis-ci.org/Availity/availity-reactstrap-validation) [![Coverage Status](https://coveralls.io/repos/github/Availity/availity-reactstrap-validation/badge.svg?branch=master)](https://coveralls.io/github/Availity/availity-reactstrap-validation?branch=master)

# availity-reactstrap-validation

Easy to use React validation components compatible for reactstrap.


## Installation

Install `availity-reactstrap-validation` and `reactstrap` via NPM

```sh
npm install --save availity-reactstrap-validation reactstrap
```

If applicable, install a `Promise` polyfill.  For example:

```sh
npm install es6-promise --save
```

The polyfill can be applied into your web application by using tools like Webpack or Babel.

Import the components you need, example:

```js
import { AvField } from 'availity-reactstrap-validation';
```

## Development

Install dependencies:

```sh
npm install
```

Run examples at [http://localhost:8080/](http://localhost:8080/) with Webpack dev server:

```sh
npm start
```

Run tests:

```sh
npm test
```

Run tests & coverage report:

```sh
npm run test:coverage
```

Watch tests:

```sh
npm run test:watch
```

## Disclaimer
Open source software components distributed or made available in the Availity Materials are licensed to Company under the terms of the applicable open source license agreements, which may be found in text files included in the Availity Materials.

## LICENSE [MIT](LICENSE)
